<?php
/******************************************************************************
*  Xaseco2 plugin (TM2)                                                       
*  Description : Spectator waiting management   
*  Configuration: Editable (see below)                                                        
*                                                                             
*  Author: mikey                                                              
*  Version: 0.41                                                                
******************************************************************************/   

Aseco::registerEvent('onStartup', 'SpecJamInit');
Aseco::registerEvent('onBeginMap', 'SpecJamNewMap');
Aseco::registerEvent('onRestartMap', 'SpecJamRestart');
Aseco::registerEvent('onPlayerConnect', 'SpecJamJoin');
Aseco::registerEvent('onPlayerDisconnect', 'SpecJamLeft');
Aseco::registerEvent('onPlayerInfoChanged', 'SpecJamChanged');
Aseco::registerEvent('onEndMap', 'SpecJamPodium');
Aseco::registerEvent("onEverySecond", "countSpecJam");
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'specJamClick');
Aseco::addChatCommand('spec', 'SpecJam info');


function SpecJamInit($aseco) {
  global $aseco, $spec_cfg, $jam;

// Start config paramaters *Edit 
  $spec_cfg['WaitMax'] = 8;               // Number of slots available in waiting line
  $spec_cfg['Worst'] = 2;                 // Number of players to Kick each race end , zero disable
  $spec_cfg['Kick'] = 1;                  // Kick Method 0=Kick 1=Force to Spec 2=Force to Spec & add to wait
  $spec_cfg['Admin'] = true;              // Kick admins (only if kick is used) 
// End config paramaters 

  $jam['WaitList'] = array_fill(0,$spec_cfg['WaitMax']+2,-1);
  $jam['WaitList'][0] = 0;                // The waiting list
  $jam['PlayList'] = array(0);            // Map start playing list 
  $jam['PlayMax'] = 0;                    // Server Max Players 
  $jam['SpecMax'] = 0;                    // Server Max Spectators 
  $jam['Players'] = 0;                    // Current Number of Players 
  $jam['Specers'] = 0;                    // Current Number of Spectators 
  $jam['Ticker'] = 5;                     // SpecJam main ticker  
  $jam['Checker'] = 0;                    // Check wait ticker  
  $jam['Status'] = 0;                     // Plugin Status  
  $jam['Results'] = array();              // Finish results   
}


function chat_spec($aseco, $command) {
  global $aseco, $spec_cfg, $jam;
  $player = $command['author'];
  $login = $player->login;
  $msg = '$i$FF0For Admin usage only';
  $arglist = explode(' ', $command['params'], 2);   // split params into arrays & insure optional parameters exist
  if (!isset($arglist[1])) $arglist[1] = '';
  $command['params'] = explode(' ', preg_replace('/ +/', ' ', $command['params']));
  if (!isset($command['params'][1])) $command['params'][1] = '';
    if ($aseco->isMasterAdmin($player) || $aseco->isAdmin($player)) {   // admin
    if ($command['params'][0] == 'help') {
        $msg = '$i$FF0Spec ??';
    }
  }
  $aseco->client->query('ChatSendServerMessageToLogin', $msg, $login);     
}


function SpecJamNewMap($aseco, $map) {                    // new map
  global $aseco, $spec_cfg, $jam;
  $jam['Status'] = 1; 
  $jam['Checker'] = 0;
  $jam['PlayMax'] = $aseco->server->maxplay ;
  $jam['SpecMax'] = $aseco->server->maxspec ;
  $plyrlist= $aseco->server->players->player_list;
  $play = 0;
  $spec = 0;
  foreach($plyrlist as $data) {	                 
    if (!$data->isspectator) {                    // create starting player list
      $play++;
      $jam['PlayList'][$play]=$data->login;
    } else {                                      // check spectators
      $spec++;
      if (array_search($data->login, $jam['WaitList'])==false) joinwait_manialink($aseco, $data->login);
    } 
  }
  $jam['PlayList'][0] =$play;
  $jam['Players'] =$play; 
  if ($jam['Checker'] < $jam['Ticker']) $jam['Checker']=$jam['Ticker']+1 ; //checkwait($aseco);
}


function SpecJamRestart($aseco, $player) {        // player join
  global $aseco, $spec_cfg, $jam;
  $jam['Status'] = 3;
  } 

function SpecJamJoin($aseco, $player) {           // player join
  global $aseco, $spec_cfg, $jam;
  $login = $player->login;
  $isspec = $player->isspectator;
  if ($isspec>0 ) {
    joinwait_manialink($aseco, $login);           // do manialink for join que
  }  
}


function SpecJamLeft($aseco, $player) {           // player left
  global $aseco, $spec_cfg, $jam;
  $login = $player->login;
  $aseco->client->addCall('SpectatorReleasePlayerSlot', array($login));	
  $left= array_search($login, $jam['WaitList']);
  if ($left >0) {
    $jam['WaitList'][$left]=-1;
    $jam['WaitList'][0]--;
  } 
  if ($jam['Checker'] < $jam['Ticker']) $jam['Checker']=$jam['Ticker']+2 ;   
}


function SpecJamChanged($aseco, $player) {        // player new info
  global $aseco, $spec_cfg, $jam;
  $login = $player['Login'];
  $spec = substr($player['SpectatorStatus'], -1, 1);
  if ($spec==1) {
    if (array_search($login, $jam['PlayList'])>0) {     // was a player

// print(' >>> Release player slot '. $login. ', Timer '.$jam['Ticker'] ." \n\r");   // debug                                           // debug

      $aseco->client->addCall('SpectatorReleasePlayerSlot', array($login));
      if ($jam['Checker'] < $jam['Ticker']) $jam['Checker']=$jam['Ticker']+5 ; 
    }
    if (array_search($login, $jam['WaitList'])>0) {    // spec is already waiting
      if ($jam['Checker'] < $jam['Ticker']) $jam['Checker']=$jam['Ticker']+2 ; 
    } else {                                           // spec is not waiting
      joinwait_manialink($aseco, $login) ;    
    }
  }   
}


function SpecJamPodium($aseco, $command) {        // EndRace
  global $aseco, $spec_cfg, $jam;
  if ($jam['Status'] == 1) $jam['Status'] = 2;
  $jam['Results'] = $command[0];
  $jam['Ticker'] = 0;
                                                          // clear manialinks
  $xml = '<manialink id="0815470000271">
    </manialink>';
  $aseco->client->addCall('SendDisplayManialinkPage', array($xml, -1, false));
  $xml = '<manialink id="0815470000272">
    </manialink>';
  $aseco->client->addCall('SendDisplayManialinkPage', array($xml, -1, false));
}

function countSpecJam($aseco, $command) {                // every second
  global $aseco, $spec_cfg, $jam;
  $jam['Ticker']++;
  if ($jam['Ticker']==3) kickworst($aseco); 
  if ($jam['Checker'] == $jam['Ticker']) checkwait($aseco); 
}


function specJamClick($aseco, $answer) {          // $answer[0]=PlayerUid, $answer[1]=Login, $answer[2]=Answer
  global $aseco, $spec_cfg, $jam;
  $login =	$answer[1];
  $player = $aseco->server->players->getPlayer($answer[1]);
				
  if ($answer[2] == 2702701) {                    // joined waiting list
    $xml = '<manialink id="0815470000271">
      </manialink>';
    $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, -1, false));
    addwait($aseco,$login) ;
    if ($jam['Checker'] < $jam['Ticker']) $jam['Checker']=$jam['Ticker']+1 ; //checkwait($aseco);
	} 
	
  if ($answer[2] == 2702702) { 

  }   
} 


// functions that are called from events

function addwait($aseco,$login) {
  global $aseco, $spec_cfg, $jam;
  $loop = 1;
  while ($loop <= $spec_cfg['WaitMax']) {
    if ($jam['WaitList'][$loop]==-1) {            // Waiting slot is available
      $jam['WaitList'][$loop]=$login;
      $jam['WaitList'][$loop+1]=-1;
      $jam['WaitList'][0]++;
      $loop=$spec_cfg['WaitMax']+1;
    }
    $loop++;  
  }
}   

function kickworst($aseco) {
  global $aseco, $spec_cfg, $jam;
  $starters= 0;
  $finishers = 0 ; 
  $play = 0;
  $spec = 0;
  $plyrlist= $aseco->server->players->player_list;
  foreach($plyrlist as $data) {	                          // count players + spec
    if (!$data->isspectator) $play++;
    else $spec++;
    $check=1;
    while ($check <= $jam['PlayMax']+$jam['SpecMax']) {   // count starting players
      if (isset($jam['PlayList'][$check]) && $data->login == $jam['PlayList'][$check]) $starters++; 
      $check++;  
    }
  }  
  foreach($jam['Results'] as $data) {                     // count finishers
    if ($data['Rank'] > 0) $finishers++;
    }
  if ($jam['PlayMax'] > $finishers) $kick=0;
  else $kick=$spec_cfg['Worst']-($finishers-$starters);   // less kicks if players left mid race
  if ($kick > $jam['WaitList'][0]) $kick=$jam['WaitList'][0];
  if ($jam['Status'] == 3) $kick=0; 
  $worst = $finishers ; 

//  print('<< Playing List '. " \n\r");   // debug 
//  print_r($jam['PlayList']);
//  print('>> Wait List '. " \n\r");      // debug 
//  print_r($jam['WaitList']);            // debug
//  print('>> sort results '." \n\r");    // debug 
//  print_r($jam['Results']);             // debug
//  print('>> Worst Kick='.$spec_cfg['Worst'].' ToKick='.$kick.' Start='.$starters.' Finish='.$finishers." \n\r");   // debug  

  while($kick > 0) {
    foreach($jam['Results'] as $data) {
      $action=$spec_cfg['Kick'];
      if ($data['Rank'] == $worst && array_search($data['Login'], $jam['PlayList'])>0) {    // worst + starter
        if ($aseco->isMasterAdmin($data['Login']) && $spec_cfg['Admin'] <> true) $action=1;
        if ($aseco->isAdmin($data['Login']) && $spec_cfg['Admin'] <> true) $action=1;
        if ($spec >= $jam['SpecMax']) $action=0;        // if too many spec, kick
        if ($action ==0) {                              // kick
          $msg = $data['Nickname'] .'$z$f80$s  has been Kicked, for worst place finish.' ;
//          $aseco->client->addCall('Kick', array($data['Login']));
          $aseco->client->query('Kick', $data['Login']);
          $aseco->client->addCall('SpectatorReleasePlayerSlot', array($data['Login']));
        }      
        if ($action >0 ) {                              // Force to spec admin ?
//   print(' >>> Kick player '. $data['Login'].', Timer '.$jam['Ticker'] ." \n\r");   // debug  
          $msg = $data['NickName'] .'$z$f80$s  has been forced to spectator, for worst placed finish.' ;
//          $aseco->client->addCall('ForceSpectator', array($data['Login'],1));
          $aseco->client->query('ForceSpectator', $data['Login'], 1);
          if ($action ==2 && $jam['WaitList'][0]<$spec_cfg['WaitMax']) addwait($aseco,$data['Login']) ;    // add to waiting list
        } 
        $kick--;
        $aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($msg))); 
      }
    } 
  $worst--;                                                        
  } 
  $jam['Checker'] = $jam['Ticker']+4 ;     
}    


function checkwait($aseco) {
  global $aseco, $spec_cfg, $jam;
  $plyrlist= $aseco->server->players->player_list;
  $loop=1;
  $waiting=0;
  while ($loop<=$spec_cfg['WaitMax']) {             // update waiting list  
    if ($jam['WaitList'][$loop]==-1) {
      $shift=$loop;
      while ($shift<=$spec_cfg['WaitMax']) {
        $jam['WaitList'][$shift]=$jam['WaitList'][$shift+1];          
        $jam['WaitList'][$shift+1]= -1;
        $shift++;
      }
    } else $waiting++;
    $loop++;  
  }
  $jam['WaitList'][0]=$waiting;

//  print(' > Doing check wait 2 List updated '." \n\r");   // debug   
//  print('<< waiting list '." \n\r");   // debug 
//  print_r($jam['WaitList']);   // debug
//  print('>> Player list '." \n\r");   // debug 
//  print_r($plyrlist);   // debug    help find nick

  $play = 0;
  $spec = 0;
  foreach($plyrlist as $data) {	                    // count current players     
    if (!$data->isspectator) $play++;
    else $spec++;
  }     
 
  $jam['Players']=$play;
  $count=$jam['PlayMax']-$jam['Players'];          
  while($count>0) {                                 // if current less than max force to play
    if ($jam['WaitList'][1] != -1) {
//          print(' > Doing Check Wait 3B force to play '.$jam['WaitList'][1]." \n\r");   // debug  

      $nick=$aseco->server->players->player_list[$jam['WaitList'][1]]->nickname ;   
      $msg = $nick .' $z$s$f80has joined play !' ;    
//      $aseco->client->query('ForceSpectator', $jam['WaitList'][1], 2);   
      $aseco->client->addCall('ForceSpectator', array($jam['WaitList'][1],2));
      $aseco->client->addCall('ForceSpectator', array($jam['WaitList'][1],0));
      $aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($msg))); 
      $xml = '<manialink id="0815470000272">
        </manialink>';
      $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($jam['WaitList'][1], $xml, -1, false));

      $loop=2;
      while ($loop<=$spec_cfg['WaitMax']) {
        $jam['WaitList'][$loop-1]=$jam['WaitList'][$loop];
        $loop++;
      }
      $jam['WaitList'][$spec_cfg['WaitMax']]=-1;
      $jam['WaitList'][0]--;
      
    }
  $count--;  
  }
  updatewait_manialink($aseco);  
}

  
function joinwait_manialink($aseco, $login) {
  global $aseco, $spec_cfg, $jam;
  $aseco->client->addCall('ForceSpectator', array($login,0));
  $aseco->client->addCall('ForceSpectator', array($login,1));
  if ($jam['Status'] == 1) {
    if ($jam['WaitList'][0] < $spec_cfg['WaitMax']) $message='$fff$sClick to join spectator waiting list';
    else $message='$f00The waiting list is full !';
    $xml = '<manialink id="0815470000271">
      <format style="TextStaticSmall" textsize="1" />
        <frame posn="0 35 0">
          <quad posn="0 0 0" sizen="30 6.0"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgPlayerName" action="2702701"/>
          <quad posn="-14.3 2.5 1" sizen="5 5" style="Icons64x64_1" substyle="Camera" action="2702701"/>
          <label posn="2.7 1.5 1" sizen="26 4" halign="center" valign="center" scale="0.8 0.8" text="$aaaStatus: Non playing spectator      Waiting: '.$jam['WaitList'][0].'/'.$spec_cfg['WaitMax'].'" action="2702701"/>
          <label posn="2.7 -0.7 1" sizen="26 4" halign="center" valign="center" scale="1.0 1.0" text="'.$message.'" action="2702701"/>
        </frame>
    </manialink>'; 
  $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml, 0, false));   
  } 

}     


function updatewait_manialink($aseco) {
  global $aseco, $spec_cfg, $jam;
  $posi = 1;
  while ($posi <= $spec_cfg['WaitMax']) {
    if ($jam['WaitList'][$posi] != -1) {  
      if ($jam['Status'] == 1) {            // is player waiting ?
        $xml = '<manialink id="0815470000272">
          <format style="TextStaticSmall" textsize="1" />
            <frame posn="0 35 0">
              <quad posn="0 0 0" sizen="30 6.0"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgCardSystem" />
              <quad posn="-14.3 2.5 1" sizen="5 5" style="Icons64x64_1" substyle="CameraLocal" action="2702702"/>
              <label posn="2.7 1.5 1" sizen="26 4" halign="center" valign="center" scale="0.8 0.8" text="$aaaStatus: Waiting spectator       Waiting: '.$jam['WaitList'][0].'/'.$spec_cfg['WaitMax'].'" action="2702702"/>
              <label posn="2.7 -0.7 1" sizen="26 4" halign="center" valign="center" scale="1.0 1.0" text="$eeeCurrently waiting postion $fff$s'.$posi.'" action="2702702"/>
              </frame>
            </manialink>'; 
        $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($jam['WaitList'][$posi], $xml, 0, false));
      }
      if ($jam['Status'] == 2) {
        $xml = '<manialink id="0815470000272">
          <format style="TextStaticSmall" textsize="1" />
            <frame posn="29.4 -24.75 0">
              <quad posn="0 0 0" sizen="7.0 4.0"  halign="center" valign="center" style="BgsPlayerCard" substyle="BgCardSystem" />
              <quad posn="-2.8 2 1"  sizen="4 4" style="Icons64x64_1" substyle="CameraLocal" action="2702702"/>
              <label posn="2.2 0.2 1" sizen="4 4" halign="center" valign="center" scale="1.0 1.0" text="$FFF'.$posi.'" action="2702702"/>
              </frame>
            </manialink>'; 
        $aseco->client->addCall('SendDisplayManialinkPageToLogin', array($jam['WaitList'][$posi], $xml, 20, false));
      }  
    }
  $posi++;  
  }
}
?>     